/*
 * Scrambler.cpp: A class for drawing the ground.
 */


#include "Cart.h"
#include "libtarga.h"
#include <stdio.h>
#include <GL/glu.h>

// Destructor
Cart::~Cart(void)
{
    if ( initialized )
    {
	glDeleteLists(cart_list, 1);
    }
}


// Initializer. Returns false if something went wrong, like not being able to
// load the texture.
bool
Cart::Initialize(void)
{
    
	// Now do the geometry. Create the display list.
    cart_list = glGenLists(1);
    glNewList(cart_list, GL_COMPILE);
	
	// Draw the ground as a quadrilateral, specifying texture coordinates.
	glBegin(GL_QUADS);
		
		
		glColor3f(1.0f,1.0f,1.0f);
		glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(9.0f, -0.3f, 4.2f);
		glVertex3f(9.0f, 0.3f, 4.2f);
		glVertex3f(0.0f, 0.3f, 4.2f);
		glVertex3f(0.0f, -0.3f, 4.2f);

		glNormal3f(0.0f, 0.0f, -1.0f);
		glVertex3f(0.0f, -0.3f, 3.6f);
		glVertex3f(0.0f, 0.3f, 3.6f);
		glVertex3f(9.0f, 0.3f, 3.6f);
		glVertex3f(9.0f, -0.3f, 3.6f);

		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(9.0f, 0.3f, 4.2f);
		glVertex3f(9.0f, -0.3f, 4.2f);
		glVertex3f(9.0f, -0.3f, 3.6f);
		glVertex3f(9.0f, 0.3f, 3.6f);

		glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(9.0f, 0.3f, 4.2f);
		glVertex3f(9.0f, 0.3f, 3.6f);
		glVertex3f(0.3f, 0.3f, 3.6f);
		glVertex3f(0.3f, 0.3f, 4.2f);

		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(9.0f, -0.3f, 3.6f);
		glVertex3f(9.0f, -0.3f, 4.2f);
		glVertex3f(0.3f, -0.3f, 4.2f);	
		glVertex3f(0.3f, -0.3f, 3.6f);

		
		glColor3f(1.0f,0.0f,0.0f);

		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(9.4f, 0.4f, 3.0f);
		glVertex3f(9.4f, -0.4f, 3.0f);
		glVertex3f(9.4f, -0.4f, 1.0f);
		glVertex3f(9.4f, 0.4f, 1.0f);
		
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(7.4f, -0.4f, 3.0f);
		glVertex3f(7.4f, 0.4f, 3.0f);
		glVertex3f(7.4f, 0.4f, 1.0f);
		glVertex3f(7.4f, -0.4f, 1.0f);

		glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(9.4f, 0.4f, 1.0f);
		glVertex3f(9.4f, -0.4f, 1.0f);
		glVertex3f(9.4f, -0.4f, 3.0f);
		glVertex3f(9.4f, 0.4f, 3.0f);

		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(7.4f, -0.4f, 1.0f);
		glVertex3f(7.4f, 0.4f, 1.0f);
		glVertex3f(7.4f, 0.4f, 3.0f);
		glVertex3f(7.4f, -0.4f, 3.0f);

		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(7.4f, 0.4f, 1.0f);
		glVertex3f(7.4f, -0.4f, 1.0f);
		glVertex3f(9.4f, -0.4f, 1.0f);
		glVertex3f(9.4f, 0.4f, 1.0f);

		glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(9.4f, 0.4f, 1.0f);
		glVertex3f(9.4f, -0.4f, 1.0f);
		glVertex3f(7.4f, -0.4f, 1.0f);
		glVertex3f(7.4f, 0.4f, 1.0f);

		glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(7.4f, 0.4f, 1.0f);
		glVertex3f(7.4f, 0.4f, 2.0f);
		glVertex3f(9.4f, 0.4f, 2.0f);
		glVertex3f(9.4f, 0.4f, 1.0f);

		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(7.4f, 0.4f, 2.0f);
		glVertex3f(7.4f, 0.4f, 1.0f);
		glVertex3f(9.4f, 0.4f, 1.0f);
		glVertex3f(9.4f, 0.4f, 2.0f);

		glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(7.4f, -0.4f, 1.0f);
		glVertex3f(7.4f, -0.4f, 2.0f);
		glVertex3f(9.4f, -0.4f, 2.0f);
		glVertex3f(9.4f, -0.4f, 1.0f);

		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(7.4f, -0.4f, 2.0f);
		glVertex3f(7.4f, -0.4f, 1.0f);
		glVertex3f(9.4f, -0.4f, 1.0f);
		glVertex3f(9.4f, -0.4f, 2.0f);

		
		



		

		//glVertex3f(
		
	   
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.0f,0.0f,0.0f);
	glVertex3f(8.f, 0.0f, 4.2f);
	glVertex3f(0.0f, 0.0f, 5.0f);

	glVertex3f(9.4f, 0.0f, 3.0f);
	glVertex3f(9.0f, 0.0f, 3.6f);

	glVertex3f(7.4f, 0.0f, 3.0f);
	glVertex3f(7.8f, 0.0f, 3.6f);
	glEnd();
		

	
    glEndList();

    // We only do all this stuff once, when the GL context is first set up.
    initialized = true;

    return true;
}


// Draw just calls the display list we set up earlier.
void
Cart::Draw(float offset, float direction)
{
    glPushMatrix();
	glRotatef((degrees * direction) + offset, 0.0f, 0.0f, -1.0f);

	for(int i = 0; i < 4; i++){
		glRotatef(90.0f, 0.0f, 0.0f, 1.0f);
		glCallList(cart_list);
		
    }

	glPopMatrix();
	degrees = degrees + 1.0f;
	if(degrees > 360.0f) degrees = degrees - 360.0f;
}