/*
 * House.h: Header file for a class that draws the ground.
 *
 * (c) 2001-2002: Stephen Chenney, University of Wisconsin at Madison.
 */


#include <Fl/gl.h>


class House {
  private:
    GLubyte house_list;   // The display list that does all the work.
	GLuint  wood_texture_obj;    // The object for the wood texture.
	GLuint  door_texture_obj;    // The object for the door texture.
	GLuint  shingle_texture_obj;    // The object for the door texture.
    bool    initialized;    // Whether or not we have been initialised.


  public:
    // Constructor. Can't do initialization here because we are
    // created before the OpenGL context is set up.
    House(void) {house_list = 0; initialized = false;};

    // Destructor. Frees the display lists and texture object.
    ~House(void);

    // Initializer. Creates the display list.
    bool    Initialize(void);

    // Does the drawing.
    void    Draw(void);
};
