/*
 * Scrambler.cpp: A class for drawing the ground.
 */


#include "Scrambler.h"
#include "libtarga.h"
#include <stdio.h>
#include <GL/glu.h>
#include <FL/math.h>


// Destructor
Scrambler::~Scrambler(void)
{
    if ( initialized )
    {
	glDeleteLists(scrambler_list, 1);
    }
}


// Initializer. Returns false if something went wrong, like not being able to
// load the texture.
bool
Scrambler::Initialize(void)
{
    
	// Now do the geometry. Create the display list.
    scrambler_list = glGenLists(1);
    glNewList(scrambler_list, GL_COMPILE);
	glColor3f(1.0f,1.0f,1.0f);
	// Draw the ground as a quadrilateral, specifying texture coordinates.
	glBegin(GL_QUADS);
		
		
		
		glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(10.0f, -0.3f, 5.6f);
		glVertex3f(10.0f, 0.3f, 5.6f);
		glVertex3f(0.0f, 0.3f, 5.6f);
		glVertex3f(0.0f, -0.3f, 5.6f);

		glNormal3f(0.0f, 0.0f, -1.0f);
		glVertex3f(0.0f, -0.3f, 5.0f);
		glVertex3f(0.0f, 0.3f, 5.0f);
		glVertex3f(10.0f, 0.3f, 5.0f);
		glVertex3f(10.0f, -0.3f, 5.0f);

		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(10.0f, 0.3f, 5.6f);
		glVertex3f(10.0f, -0.3f, 5.6f);
		glVertex3f(10.0f, -0.3f, 5.0f);
		glVertex3f(10.0f, 0.3f, 5.0f);

		glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(10.0f, 0.3f, 5.6f);
		glVertex3f(10.0f, 0.3f, 5.0f);
		glVertex3f(0.3f, 0.3f, 5.0f);
		glVertex3f(0.3f, 0.3f, 5.6f);

		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(10.0f, -0.3f, 5.0f);
		glVertex3f(10.0f, -0.3f, 5.6f);
		glVertex3f(0.3f, -0.3f, 5.6f);	
		glVertex3f(0.3f, -0.3f, 5.0f);
	
		

		//glVertex3f(
		
	   
	glEnd();

	glBegin(GL_LINES);
	glColor3f(0.0f,0.0f,0.0f);
	glVertex3f(9.3f, 0.0f, 5.6f);
	glVertex3f(0.0f, 0.0f, 7.0f);
	glEnd();

	/*glBegin(GL_TRIANGLES);
		glColor3f(0.0f,0.0f,0.0f);
		
		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(0.5f, -0.5f, 5.6f);
		glVertex3f(0.5f, 0.5f, 5.6f);
		glVertex3f(0.0f, 0.0f, 7.0f);

		
	glEnd();*/
	
    glEndList();

	cart.Initialize();

    // We only do all this stuff once, when the GL context is first set up.
    initialized = true;

    return true;
}


// Draw just calls the display list we set up earlier.
void
Scrambler::Draw(void)
{
	glPushMatrix();
	glTranslatef(-25.0f, 25.0f, 0.0f);
    glBegin(GL_QUADS);
		glColor3f(0.0f,0.0f,0.0f);
		
		glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.3f, 0.3f, 5.0f);
		glVertex3f(0.3f, 0.3f, 0.0f);
		glVertex3f(-0.3f, 0.3f, 0.0f);
		glVertex3f(-0.3f, 0.3f, 5.0f);
		
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(-0.3f, 0.3f, 5.0f);
		glVertex3f(-0.3f, 0.3f, 0.0f);
		glVertex3f(-0.3f, -0.3f, 0.0f);
		glVertex3f(-0.3f, -0.3f, 5.0f);
	
		glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(-0.3f, -0.3f, 5.0f);
		glVertex3f(-0.3f, -0.3f, 0.0f);
		glVertex3f(0.3f, -0.3f, 0.0f);
		glVertex3f(0.3f, -0.3f, 5.0f);
			
		
		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(0.3f, -0.3f, 5.0f);
		glVertex3f(0.3f, -0.3f, 0.0f);
		glVertex3f(0.3f, 0.3f, 0.0f);
		glVertex3f(0.3f, 0.3f, 5.0f);

		glNormal3f(1.0f, 0.0f, 0.0f);
		glVertex3f(0.3f, 0.3f, 4.9f);
		glVertex3f(-0.3f, 0.3f, 4.9f);
		glVertex3f(-0.3f, -0.3f, 4.9f);
		glVertex3f(0.3f, -0.3f, 4.9f);
		
	glEnd();

	glPushMatrix();
	//glRotatef(90.0f, 0.0f, 1.0f, 0.0f);
	glRotatef(cos(degrees) * 700.0f, 0.0f, 0.0f, 1.0f);
    
	for(int i = 0; i < 4; i++){
		glRotatef(90.0f, 0.0f, 0.0f, 1.0f);
		glPushMatrix();
		glTranslatef(10.0f, 0.0f, 0.0f);
		if(i % 2 == 0){
			cart.Draw(0.0f, 1.0f);
		}else{
			cart.Draw(45.0f, -1.0f);
		}
		glPopMatrix();
		glCallList(scrambler_list);
		

    }

	

	glPopMatrix();
	glPopMatrix();
	
	//degrees = degrees + 1.0f;
	degrees = degrees + 0.005f;
	if(degrees > 2 * M_PI) degrees = degrees - 2 * M_PI;
}