/*
 * Scrambler.h: Header file for a class that draws the ground.
 *
 * (c) 2001-2002: Stephen Chenney, University of Wisconsin at Madison.
 */


#include <Fl/gl.h>
#include "Cart.h"
#include <math.h>

class Scrambler {
  private:
    GLubyte scrambler_list;   // The display list that does all the work.
    bool    initialized;    // Whether or not we have been initialised.
	float	degrees;		// current rotation
	


  public:
	  
	Cart	cart;
    
	// Constructor. Can't do initialization here because we are
    // created before the OpenGL context is set up.
    Scrambler(void) { scrambler_list = 0; initialized = false; degrees = 0.0;};

    // Destructor. Frees the display lists and texture object.
    ~Scrambler(void);

    // Initializer. Creates the display list.
    bool    Initialize(void);

    // Does the drawing.
    void    Draw(void);

	// Gets degrees.
    float    getDegrees(void) {return cos(degrees) * 700.0f;};
};



