/*
 * Tree.cpp: A class for drawing the ground.
 */


#include "Tree.h"
#include "libtarga.h"
#include <stdio.h>
#include <GL/glu.h>


// Destructor
Tree::~Tree(void)
{
    if ( initialized )
    {
	glDeleteLists(tree_list, 1);
    }
}


// Initializer. Returns false if something went wrong, like not being able to
// load the texture.
bool
Tree::Initialize(float height, float width)
{
    

	// Now do the geometry. Create the display list.
    tree_list = glGenLists(1);
    glNewList(tree_list, GL_COMPILE);
	glColor3f(0.0f,0.5f,0.0f);

	glBegin(GL_TRIANGLES);
		glNormal3f(0.5f * height,0.0f,0.5f * width);
		glVertex3f(0.0f * width, 0.0f * width, 1.0f * height);
		glVertex3f(0.25f * width,-0.25f * width, 0.75f * height);
		glVertex3f(0.25f * width,0.25f * width, 0.75f * height);
		
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.25f * width,0.25f * width, 0.75f * height);
		glVertex3f(0.25f * width,-0.25f * width, 0.75f * height);
		glVertex3f(0.0f * width,0.0f * width, 0.75f * height);

		glVertex3f(0.375f * width, 0.375f * width, 0.5f * height);
		glVertex3f(0.375f * width, -0.375f * width, 0.5f * height);
		glVertex3f(0.0f * width,0.0f * width, 0.5f * height);

		glVertex3f(0.5f * width,0.5f * width,0.25f * height);
		glVertex3f(0.5f * width,-0.5f * width,0.25f * height);
		glVertex3f(0.0f * width,0.0f * width, 0.25f * height);
		
	glEnd();
	
	glBegin(GL_QUADS);
		glNormal3f(0.5f * height,0.0f,0.5f * width);
		
		glVertex3f(0.375f * width, -0.375f * width, 0.5f * height);
		glVertex3f(0.375f * width, 0.375f * width, 0.5f * height);
		glVertex3f(0.125f * width,0.125f * width, 0.75f * height);
		glVertex3f(0.125f * width,-0.125f * width, 0.75f * height);

		glVertex3f(0.25f * width,0.25f * width, 0.5f * height);
		glVertex3f(0.25f * width,-0.25f * width, 0.5f * height);
		glVertex3f(0.5f * width,-0.5f * width, 0.25f * height);
		glVertex3f(0.5f * width,0.5f * width, 0.25f * height);
		
		glColor3f(0.37f,0.25f,0.12f);
		glVertex3f(0.125f * width,0.125f * width,0.25f * height);
		glVertex3f(0.125f * width,-0.125f * width,0.25f * height);
		glVertex3f(0.125f * width,-0.125f * width,0.0f * height);
		glVertex3f(0.125f * width,0.125f * width,0.0f * height);

	glEnd();

	

	
	
    glEndList();


    // We only do all this stuff once, when the GL context is first set up.
    initialized = true;

    return true;
}


// Draw just calls the display list we set up earlier.
void
Tree::Draw(void)
{

	glPushMatrix();
	   
	for(int i = 0; i < 4; i++){
		glRotatef(90.0f, 0.0f, 0.0f, 1.0f);
		glCallList(tree_list);
    }

	glPopMatrix();


		
}