/*
 * Tree.h: Header file for a class that draws the ground.
 *
 * (c) 2001-2002: Stephen Chenney, University of Wisconsin at Madison.
 */


#include <Fl/gl.h>


class Tree {
  private:
    GLubyte tree_list;   // The display list that does all the work.
	bool    initialized;    // Whether or not we have been initialised.


  public:
    // Constructor. Can't do initialization here because we are
    // created before the OpenGL context is set up.
    Tree(void) {tree_list = 0; initialized = false;};

    // Destructor. Frees the display lists and texture object.
    ~Tree(void);

    // Initializer. Creates the display list.
    bool    Initialize(float height, float width);

    // Does the drawing.
    void    Draw(void);
};
